var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
import { Animated, Easing, Text } from "react-native";
import React, { useState, useRef, useEffect, useCallback } from "react";
var SMOOTH_OFFSET = 30;
var RollingText = function (_a) {
    var children = _a.children, force = _a.force, debug = _a.debug, containerStyle = _a.containerStyle, style = _a.style, _b = _a.startDelay, startDelay = _b === void 0 ? 2000 : _b, _c = _a.delay, delay = _c === void 0 ? 0 : _c, _d = _a.durationMsPerWidth, durationMsPerWidth = _d === void 0 ? 25 : _d;
    var _e = useState(0), width = _e[0], setWidth = _e[1];
    var _f = useState(0), textWidth = _f[0], setTextWidth = _f[1];
    var animation = useRef(new Animated.Value(0)).current;
    var logger = useCallback(function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return (debug && __DEV__ ? console.log.apply(console, __spreadArray(["[debug-marquee]"], args)) : function () { });
    }, [debug]);
    useEffect(function () {
        if (width === 0 || textWidth === 0)
            return;
        logger("container width:", width);
        logger("text width:", textWidth);
        var marquee, timeout;
        if (force || width < textWidth) {
            logger("marquee animation triggered");
            animation.setValue(0);
            var durationPerRange = durationMsPerWidth;
            var initialTranslateRange = textWidth;
            var translateRange = width + textWidth;
            var initialDuration = Math.round(initialTranslateRange * durationPerRange);
            var duration = Math.round(translateRange * durationPerRange);
            var sequence = Animated.sequence([
                Animated.timing(animation, {
                    useNativeDriver: true,
                    duration: duration,
                    toValue: -textWidth - SMOOTH_OFFSET,
                    easing: Easing.linear
                }),
                Animated.timing(animation, {
                    useNativeDriver: true,
                    duration: 0,
                    delay: delay,
                    toValue: width,
                    easing: Easing.linear
                })
            ]);
            marquee = Animated.loop(sequence, { resetBeforeIteration: true });
            logger("marquee initial animation started");
            Animated.timing(animation, {
                useNativeDriver: true,
                duration: initialDuration,
                delay: startDelay,
                toValue: -textWidth,
                easing: Easing.linear
            }).start(function (_a) {
                var finished = _a.finished;
                if (finished) {
                    logger("marquee initial animation finished");
                    timeout = setTimeout(function () {
                        animation.setValue(width);
                        marquee && marquee.start();
                    }, delay);
                    logger("marquee loop animation started");
                }
            });
        }
        return function () {
            marquee && marquee.stop();
            timeout && clearTimeout(timeout);
        };
    }, [animation, width, textWidth]);
    return (<Animated.View onLayout={function (e) { return setWidth(e.nativeEvent.layout.width); }} style={[
            containerStyle,
            { transform: [{ translateX: animation }], flexWrap: "wrap", width: "100%" },
            debug && { borderWidth: 1, borderColor: "red" }
        ]}>
            <Text numberOfLines={1} onLayout={function (e) { return setTextWidth(e.nativeEvent.layout.width); }} style={[style, debug && { borderWidth: 1, borderColor: "green" }]}>
                {children}
            </Text>
        </Animated.View>);
};
export default RollingText;
